﻿
angular.module('wjm', ['ui.bootstrap', 'ui.calendar', 'angularTreeview', 'ngDialog']).

           controller('resourceCtrl', function ($rootScope, $scope, uiCalendarConfig, $compile, ngDialog, $timeout) {
               var vm = $scope;

               var date = new Date();

               var d = date.getDate();
               var m = date.getMonth();
               var y = date.getFullYear();
               var hubber = $.connection.calendarHub;

               vm.alertMessage = "No alerts";
               vm.currentcal = [];
               vm.selectedEventId = -1;
               vm.groups = [];
               vm.clients = [];
               vm.init = function () {

                   //  $.connection.hub.logging = true;


                   var v = document.getElementById("userId").innerHTML;
                   $.connection.hub.qs = { 'userid': v };
                   $.connection.hub.start().done(function () {
                       hubber.server.requestInfo();
                   });
                   hubber.client.processData = function (data) {
                       vm.data = JSON.parse(data);
                       $scope.buildTree();

                       $scope.$apply();
                   };
                   hubber.client.savingCurrentDone = function () {
                       vm.calendarSaver = false;
                       $scope.clearCurrentCalendar();
                       $scope.$apply();
                   };
                   hubber.client.savingAllDone = function () {
                       vm.calendarSaver = false;
                       clearAllCalendarsFunc();
                       $scope.$apply();
                   };
                   hubber.client.processDispose = function (disp) {
                       vm.treeview.currentNode.IsDisposable = disp;
                       $scope.calendarDispose = false;
                       $scope.$apply();
                   }
                   hubber.client.processDowntime = function (id, down) {
                       var json = JSON.parse(down);
                       var arrdown = [];
                       var str = "";
                       for (var i = 0; i < json.length; i++) {
                           if (json[i].DowntimeType === 0) {
                               str = "Unavailable";
                               col = "#006080";
                           }
                           else {
                               str = "Shutdown";
                               col = "#993300";
                           }
                           arrdown.push({
                               id: json[i].Id,
                               title: str,
                               start: new Date(json[i].StartDate),
                               end: new Date(json[i].EndDate),
                               allDay: json[i].AllDayEvent,
                               color: col,
                               rec: {
                                   recurrence: json[i].Recurring,
                                   recid: json[i].RecurringId,
                                   days: [false, false, false, false, false, false, false],
                                   start: new Date(json[i].StartDate),
                                   end: new Date(json[i].EndDate)

                               },
                               changed: false
                           });
                       }
                       var dat = { 'id': id, 'down': [arrdown] };
                       $scope.treeview.currentNode.calendar = dat;

                       $scope.currentcal = $scope.treeview.currentNode.calendar;
                       $("#resourcecalendar").fullCalendar('refresh');
                       $scope.$apply();
                   }

                   $scope.$watch("treeview.currentNode", function (newValue, oldValue) {
                       $scope.currentcal = [];
                       $(".selected.ng-binding").addClass('loaded');
                       $scope.selectedEventId = -1;
                       if ($scope.treeview.currentNode != null && $scope.treeview.currentNode.Id != undefined) {
                           if ($scope.treeview.currentNode.calendar.length === 0) {
                               hubber.server.requestDownTime(vm.treeview.currentNode.Id);

                           }
                           else {
                               $timeout(function () {
                                   $scope.currentcal = $scope.treeview.currentNode.calendar;

                               }, 0);

                           }
                       }

                   });
               }
               $scope.clearTreeSelect = function () {
                   if (vm.treeview.currentNode != undefined) {
                       vm.treeview.currentNode.selected = undefined;
                       vm.treeview.currentNode = undefined;
                       vm.selectedEventId = -1;
                   }
               }
               $scope.buildTree = function () {
                   vm.tree = [];
                   vm.temptree = [];
                   vm.top = false;
                   var ungrouped = {
                       children: [],
                       Name: 'Ungrouped'
                   }
                   for (; vm.data.length > 0;) {

                       if (vm.data[0].ParentResourceId == null && vm.data[0].IsDisposable !== undefined) {
                           var curr = $scope.seekChildren(vm.data.splice(0, 1)[0]);
                           vm.clients.push(curr);
                           ungrouped.children.push(curr);
                       }
                       else if (vm.data[0].ParentResourceId == null) {
                           var curr = $scope.seekChildren(vm.data.splice(0, 1)[0]);
                           vm.groups.push(curr);
                           vm.tree.push(curr);
                       }
                       else {
                           var curr = $scope.seekChildren(vm.data.splice(0, 1)[0]);
                           if (curr.IsDisposable !== undefined)
                               vm.clients.push(curr);
                           else
                               vm.groups.push(curr);
                           vm.temptree.push(curr);
                       }
                   }
                   vm.tree.push(ungrouped);

               };

               $scope.seekChildren = function (current) {
                   current.calendar = [];
                   current.children = [];
                   current.todelete = [];
                   current.changes = false;
                   current.collapsed = true;
                   for (var t = 0; t < vm.temptree.length;) {
                       if (current.Id == vm.temptree[t].ParentResourceId) {
                           current.children.push(vm.temptree.splice(t, 1)[0]);
                       }
                       else {
                           t++;
                       }
                   }
                   var childc = current.children.length;//Remembers count of children received from temp tree;
                   for (var t = 0; t < vm.data.length;) {
                       if (current.Id == vm.data[t].ParentResourceId) {
                           if (vm.data[t].IsDisposable !== undefined)
                               vm.clients.push(vm.data[t]);
                           else
                               vm.groups.push(vm.data[t]);
                           current.children.push(vm.data.splice(t, 1)[0]);
                       }
                       else {
                           t++;
                       }
                   }
                   for (var t = childc; t < current.children.length; t++) {
                       current.children[t] = $scope.seekChildren(current.children[t]);
                   }
                   return current;
               }

               $scope.toggleDisposable = function () {
                   $scope.calendarDispose = true;
                   hubber.server.toggleDisposable(vm.treeview.currentNode.Id);
               }

               function collectInfoToSave(node, refresh, last) {
                   var arr = node.calendar.down[0];
                   var toadd = [];
                   var todel = node.todelete;
                   var toupd = [];
                   for (var i = 0; i < arr.length; i++) {
                       if (arr[i].id === '00000000-0000-0000-0000-000000000000') {
                           var t = arr[i].allDay.toString();
                           toadd.push([
                               arr[i].title,//status
                               "" + Date.parse(arr[i].start),//start
                               "" + Date.parse(arr[i].end),//end
                               t,// allday
                               node.Id, //resource id
                               arr[i].rec.recurrence.toString(),//true on recur
                               arr[i].rec.recid,//recur id
                               "" + Date.parse(arr[i].rec.start),
                               "" + Date.parse(arr[i].rec.end),
                               arr[i].rec.days.join(",")


                           ]);
                       }
                       else if (arr[i].changed === true) {
                           var t = arr[i].allDay.toString();
                           toupd.push([
                               arr[i].id,//id to update
                               arr[i].title,//status
                               "" + Date.parse(arr[i].start),//start
                               "" + Date.parse(arr[i].end),//end
                               t,//allday
                               arr[i].rec.recurrence.toString(),//true on recur
                               arr[i].rec.recid,//recur id
                               "" + Date.parse(arr[i].rec.start),
                               "" + Date.parse(arr[i].rec.end),
                               arr[i].rec.days.join(",")

                           ]);
                       }
                   }
                   vm.sendtoserv = [todel, toadd, toupd];
                   hubber.server.saveCalendar(node.Id, todel, toadd, toupd, refresh, last);
               }
               $scope.saveCurrentCalendar = function () {
                   vm.calendarSaver = true;
                   collectInfoToSave(vm.treeview.currentNode, true, false);
                   //true for refresh, false for showing it's only one calendar saved.
               }
               $scope.saveAllCalendars = function () {

                   $scope.allSave = [];
                   for (var i = 0; i < $scope.tree.length; i++)
                       createSaveRequests($scope.tree[i]);
                   ngDialog.openConfirm({
                       template:
                        '<p>Are you sure you want to save all changes made to ' + $scope.allSave.length + ' calendars?</p>' +
                        '<div>' +
                        '<button type="button" class="btn btn-primary" ng-click="confirm(1)">Yes' +
                        '<button type="button" class="btn btn-default" ng-click="closeThisDialog(0)">No </button> ' +
                        '</button></div>',
                       plain: true
                   }).then(function (success) {
                       vm.calendarSaver = true;
                       for (var i = 0; i < $scope.allSave.length; i++) {
                           if (i >= $scope.allSave.length - 1)
                               collectInfoToSave($scope.allSave[i], false, true);
                           else
                               collectInfoToSave($scope.allSave[i], false, false);
                       }
                   });


               }
               function createSaveRequests(node) {
                   if (node.changes === true)
                       $scope.allSave.push(node);
                   for (var i = 0; i < node.children.length; i++) {
                       createSaveRequests(node.children[i]);
                   }
               }
               $scope.clearCurrentCalendar = function () {

                   $scope.selectedEventId = -1;
                   $scope.treeview.currentNode.calendar = null;
                   $scope.treeview.currentNode.todelete = [];
                   $scope.treeview.currentNode.changes = false;
                   $scope.currentcal = [];
                   hubber.server.requestDownTime(vm.treeview.currentNode.Id);
                   $(".selected.ng-binding").removeClass('changed');


               }
               $scope.clearAllCalendars = function () {
                   ngDialog.openConfirm({
                       template:
                        '<p>Are you sure you want to delete all calendar changes?</p>' +
                        '<div>' +
                          '<button type="button" class="btn btn-default" ng-click="closeThisDialog(0)">No </button> ' +
                          '<button type="button" class="btn btn-primary" ng-click="confirm(1)">Yes' +
                        '</button></div>',
                       plain: true
                   }).then(function (success) {
                       clearAllCalendarsFunc();
                   });

               }
               function clearAllCalendarsFunc() {
                   $(".ng-binding.changed").removeClass('changed');
                   $(".ng-binding.loaded").removeClass('loaded');
                   $scope.selectedEventId = -1;
                   $scope.treeview.currentNode.calendar = null;
                   $scope.currentcal = [];
                   for (var i = 0; i < $scope.tree.length; i++)
                       clearCalendarsRecurse($scope.tree[i]);
                   hubber.server.requestDownTime(vm.treeview.currentNode.Id);
                   $(".selected.ng-binding").addClass('loaded');
               }
               function clearCalendarsRecurse(node) {

                   node.calendar = [];
                   node.todelete = [];
                   node.changes = false;
                   for (var i = 0; i < node.children.length; i++) {
                       clearCalendarsRecurse(node.children[i]);
                   }
               }
               $scope.deleteAllEvents = function () {
                   vm.calendarDeleter = true;
                   vm.selectedEventId = -1;
                   var node = vm.treeview.currentNode.calendar.down[0];
                   for (var i = 0; i < node.length;) {
                       if (node[i].id != '00000000-0000-0000-0000-000000000000')
                           vm.treeview.currentNode.todelete.push(node[i].id);
                       $scope.setChanged(vm.selectedEventId);
                       node.splice(i, 1);
                   }
                   vm.calendarDeleter = false;
                   ngDialog.open({
                       template:
                        '<p>All events have been deleted. Save the changes to confirm deletion, clearing will restore all the events from the server</p>',
                       plain: true
                   });
               }
               $scope.deleteAllPreviousEvents = function () {
                   vm.calendarDeleter = true;
                   vm.selectedEventId = -1;
                   var node = vm.treeview.currentNode.calendar.down[0];
                   for (var i = 0; i < node.length;) {
                       if (node[i].end < Date.now()) {
                           if (node[i].id != '00000000-0000-0000-0000-000000000000')
                               vm.treeview.currentNode.todelete.push(node[i].id);
                           $scope.setChanged(vm.selectedEventId);
                           node.splice(i, 1);
                       }
                       else
                           i++;
                   }
                   vm.calendarDeleter = false;
                   ngDialog.open({
                       template:
                        '<p>All previous events have been deleted. Save the changes to confirm deletion</p>',
                       plain: true
                   });
               }


               $scope.setChanged = function (id) {
                   if (id != -1) {
                       if (vm.treeview.currentNode.calendar.down[0][id].title === "Unavailable")
                           vm.treeview.currentNode.calendar.down[0][id].color = '#0099cc';
                       else
                           vm.treeview.currentNode.calendar.down[0][id].color = '#ff5500';

                       vm.treeview.currentNode.calendar.down[0][id].changed = true;
                   }
                   vm.treeview.currentNode.changes = true;
                   $(".selected.ng-binding").addClass('changed');
               }
               //*Add event by click
               $scope.calendarClick = function (date, jsEvent, view) {

                   var newid = 0;
                   if (vm.treeview.currentNode.calendar.down[0].length != 0)
                       newid = vm.treeview.currentNode.calendar.down[0][(vm.treeview.currentNode.calendar.down[0].length - 1)]._id + 1;
                   var dat = date.toDate();
                   var end = new Date(dat);
                   end.setHours(dat.getHours() + 2);
                   vm.treeview.currentNode.calendar.down[0].push({
                       id: '00000000-0000-0000-0000-000000000000',
                       title: 'Unavailable',
                       start: dat,
                       end: end,
                       allDay: date._ambigTime,
                       rec: {
                           recurrence: false,
                           recid: '0',
                           days: [false, false, false, false, false, false, false],
                           start: dat,
                           end: end

                       },
                       _id: (newid)
                   });
                   vm.selectedEventId = vm.treeview.currentNode.calendar.down[0].length - 1;
                   vm.setChanged(vm.selectedEventId);
                   $scope.currentcal = [];
                   $scope.currentcal = vm.treeview.currentNode.calendar;


               }
               function checkId(id) {
                   for (var i = 0; i < vm.treeview.currentNode.calendar.down[0].length ; i++) {
                       if (vm.treeview.currentNode.calendar.down[0][i]._id === id)
                           return i;
                   }
                   return -1;
               }
               /* alert on eventClick */
               $scope.eventClick = function (date, jsEvent, view) {
                   vm.selectedEventId = checkId(date._id);
               };
               $scope.eventClickBtn = function (id) {
                   vm.selectedEventId = checkId(id);
                   vm.goToDate();
               };
               /* alert on Drop */
               $scope.dragandDrop = function (event, delta, revertFunc, jsEvent, ui, view) {
                   vm.selectedEventId = checkId(event._id);
                   vm.setChanged(vm.selectedEventId);
                   if (event.end == null) {
                       event.end = moment(event.start).add(2, 'hours');
                   }
                   if (vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].allDay && event.start._ambigTime == false) {
                       event.allDay = false;
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].allDay = false;
                   }
                   else if (!vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].allDay && event.start._ambigTime == true) {
                       event.allDay = true;
                       vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].allDay = true;
                       //vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].end = null;
                   }
                   vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].start = new Date(event.start);
                   vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].end = new Date(event.end);
               };
               /* alert on Resize */
               $scope.resizeEvent = function (event, delta, revertFunc, jsEvent, ui, view) {
                   vm.selectedEventId = checkId(event._id);
                   vm.setChanged(vm.selectedEventId);
                   vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].start = new Date(event.start);
                   vm.treeview.currentNode.calendar.down[0][vm.selectedEventId].end = new Date(event.end);
               };

               /* remove event */
               $scope.remove = function (index) {
                   vm.selectedEventId = -1;
                   vm.setChanged(vm.selectedEventId);
                   if (vm.treeview.currentNode.calendar.down[0][index].id != "00000000-0000-0000-0000-000000000000") {
                       vm.treeview.currentNode.todelete.push(vm.treeview.currentNode.calendar.down[0][index].id);
                   }
                   vm.treeview.currentNode.calendar.down[0].splice(index, 1);


               };
               $scope.removeList = function (id) {
                   var index = checkId(id);
                   vm.selectedEventId = -1;
                   vm.setChanged(vm.selectedEventId);
                   if (vm.treeview.currentNode.calendar.down[0][index].id != "00000000-0000-0000-0000-000000000000") {
                       vm.treeview.currentNode.todelete.push(vm.treeview.currentNode.calendar.down[0][index].id);
                   }
                   vm.treeview.currentNode.calendar.down[0].splice(index, 1);


               };

               $scope.checkDateStartEnd = function () {
                   if ($scope.currentcal.down[0][vm.selectedEventId].rec.start > $scope.currentcal.down[0][vm.selectedEventId].rec.end ||
                       $scope.currentcal.down[0][vm.selectedEventId].rec.end === undefined) {

                       $scope.currentcal.down[0][vm.selectedEventId].rec.end = new Date($scope.currentcal.down[0][vm.selectedEventId].rec.start);

                   }
                   if ($scope.currentcal.down[0][vm.selectedEventId].rec.start < Date.now())
                       $scope.currentcal.down[0][vm.selectedEventId].rec.start = new Date();
               }
               //pushes all changes to other recurs
               $scope.pushRecurChanges = function (recid) {
                   ngDialog.openConfirm({
                       template:
                        '<p>This will change all existing recurrences and create new recurrences where needed. Are you sure?</p>' +
                        '<div>' +
                          '<button type="button" class="btn btn-default" ng-click="closeThisDialog(0)">No </button> ' +
                          '<button type="button" class="btn btn-primary" ng-click="confirm(1)">Yes' +
                        '</button></div>',
                       plain: true
                   }).then(function (success) {
                       var arr = vm.treeview.currentNode.calendar.down[0];
                       var ob = $.extend(true, {}, arr[vm.selectedEventId]);
                       for (var i = 0; i < arr.length;) {
                           if (arr[i].rec.recid === recid) {
                               if (new Date(arr[i].start) < new Date(ob.rec.start) ||
                                        new Date(arr[i].end) > new Date(ob.rec.end) ||
                                        !ob.rec.days[new Date(arr[i].start).getDay()]) {
                                   vm.remove(i);
                                   vm.selectedEventId = -1;

                               }
                               else {

                                   arr[i].start.setHours(ob.start.getHours(), ob.start.getMinutes());
                                   arr[i].end.setHours(ob.end.getHours(), ob.end.getMinutes());
                                   arr[i].title = ob.title;
                                   arr[i].rec = ob.rec;
                                   arr[i].allDay = ob.allDay;
                                   vm.setChanged(i);
                                   i++;
                               }
                           }
                           else
                               i++;
                       }
                       var start = new Date(ob.rec.start);
                       start.setHours(2, 0, 0, 0);
                       var end = new Date(ob.rec.end);
                       end = new Date(end.setHours(24, 0, 0, 0) + 1000 * 3600 * 2);

                       loop1:
                           for (var d = (start.getTime()) ; d < (end.getTime()) ;) {
                               var tog = ob.rec.days[new Date(d).getDay()];
                               if (tog) {
                                   loop2:
                                       for (var i = 0; i < arr.length; i++) {

                                           if (arr[i].rec.recid === recid) {
                                               var dend = (d + 1000 * 3600 * 24);
                                               if (arr[i].start.getTime() >= d &&
                                                   arr[i].end.getTime() <= dend) {
                                                   d += (1000 * 3600 * 24);
                                                   continue loop1;
                                               }
                                           }
                                       }

                                   var ts = new Date(d);
                                   ts.setHours(new Date(ob.start).getHours(), new Date(ob.start).getMinutes());
                                   var te = new Date(d);
                                   te.setHours(new Date(ob.end).getHours(), new Date(ob.end).getMinutes());
                                   arr.push({
                                       id: '00000000-0000-0000-0000-000000000000',
                                       title: ob.title,
                                       start: ts,
                                       end: te,
                                       allDay: ob.allDay,
                                       rec: ob.rec
                                   });
                                   vm.setChanged(arr.length - 1);

                               }

                               d += (1000 * 3600 * 24);// 1 day

                           }
                   });
               }
               $scope.deleteAllRecurrences = function (recid) {
                   ngDialog.openConfirm({
                       template:
                        '<p>This will delete every found recurrence. Are you sure?</p>' +
                        '<div>' +
                          '<button type="button" class="btn btn-default" ng-click="closeThisDialog(0)">No </button> ' +
                          '<button type="button" class="btn btn-primary" ng-click="confirm(1)">Yes' +
                        '</button></div>',
                       plain: true
                   }).then(function (success) {
                       var arr = vm.treeview.currentNode.calendar.down[0];
                       for (var i = 0; i < arr.length;) {
                           if (arr[i].rec.recid === recid)
                               vm.remove(i);
                           else
                               i++;
                       }
                   });
               }

               $scope.goToDate = function () {
                   $("#resourcecalendar").fullCalendar('gotoDate', vm.currentcal.down[0][vm.selectedEventId].start);
               }
               /* Render Tooltip */
               $scope.eventRender = function (event, element, view) {
                   element.attr({
                       'tooltip': event.title,
                       'tooltip-append-to-body': true
                   });
                   //$compile(element)($scope);
               };
               /* config object */
               $scope.uiConfig = {
                   calendar: {
                       height: 500,
                       editable: true,
                       defaultView: 'agendaWeek',
                       firstDay: 1,
                       header: {
                           left: 'title',
                           center: 'agendaWeek, agendaDay',
                           right: 'today prev,next'
                       },
                       timezone: 'UTC',
                       timeFormat: 'HH:mm',
                       eventClick: $scope.eventClick,
                       eventDrop: $scope.dragandDrop,
                       eventResize: $scope.resizeEvent,
                       eventRender: $scope.eventRender,
                       dayClick: $scope.calendarClick



                   }
               };



           }).filter('disp', function () {
               return function (input) {
                   return input ? 'Disposable' : 'Not disposable';
               }
           }).directive('animateOnChange', function ($timeout) {
               return function (scope, element, attr) {
                   scope.$watch(attr.animateOnChange, function (nv, ov) {

                       if (nv != ov) {
                           if (scope.currentcal.down[0][scope.selectedEventId].title === "Unavailable") {
                               element.addClass('changed');
                               $timeout(function () {
                                   element.removeClass('changed');
                               }, 250); // Could be enhanced to take duration as a parameter
                           }
                           else {
                               element.addClass('changedshut');
                               $timeout(function () {
                                   element.removeClass('changedshut');
                               }, 250); // Could be enhanced to take duration as a parameter
                           }
                       }
                   });
               };
           });


